﻿@page "/news"
@using DayZLegacy.Components
@using DayZLegacy.Services
@using Shared
@inject NavigationManager NavigationManager

<Titlebar Title="@title" OnGoBack="@HandleGoBack"/>

@if (currentDevlog is not null)
{
    <div class="p-2 pl-3 pr-3 rounded overflow-auto primary-bg hidden" @ref=element>
        <div class="text-white">
            @((MarkupString)currentDevlog.Description)
        </div>
    </div>
}
else
{
    <div class="table-container">
        <table class="table text-white table-sm table-hover rounded m-0">
            <tbody>
                @foreach (var devlog in devlogs)
                {
                    <tr style="cursor:pointer" @onclick="@(() => HandleDevlogClick(devlog))">
                        <td>@devlog.Title</td>
                        <td>@devlog.UploadDate</td>
                        <td>@devlog.Type</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
}

@code {
    [Inject]
    private DevlogService DevlogService { get; set; } = default!;
    
    [Inject]
    private IJSRuntime JSRuntime { get; set; } = default!;
    
    [Inject]
    private ConnectionService ConnectionService { get; set; } = default!;
    
    private string title = "News";
    private Devlog? currentDevlog;
    private Devlog[] devlogs = Array.Empty<Devlog>();
    private ElementReference element;

    protected override void OnInitialized()
    {
        ConnectionService.OnConnectionChanged += HandleIsConnectionChanged;
        LoadDevlogsAsync().AndForget();
    }
    
    public void Dispose()
    {
        ConnectionService.OnConnectionChanged -= HandleIsConnectionChanged;
    }
    
    private void HandleIsConnectionChanged()
    {
        NavigationManager.NavigateTo("/");
    }

    protected override void OnAfterRender(bool firstRender)
    {
        if (currentDevlog is not null)
        {
            JSRuntime.InvokeVoidAsync("applySlideDownStyle", element).AndForget();
        }
    }

    private async Task LoadDevlogsAsync()
    {
        devlogs = await DevlogService.GetDevlogsAsync();
        StateHasChanged();
    }

    private void LoadDevlog(Devlog devlog)
    {
        currentDevlog = devlog;
        title = devlog.Title;
        
        StateHasChanged();
    }

    private void HandleDevlogClick(Devlog devlog)
    {
        LoadDevlog(devlog);
    }

    private void HandleGoBack()
    {
        if (currentDevlog is null)
        {
            NavigationManager.NavigateTo("/");
        }
        else
        {
            currentDevlog = null;
            title = "News";
        }
    }
}